import React from "react";
import { useState } from "react";
import { Button } from "./Button";
import { Input } from "./Input";

export const ExplainCode = (props) => {
  //const API_KEY = "test_api_key_0001";

  const [isDisabled, setIsDisabled] = useState(false);
  const [value, setValue] = useState("");
  const [explain, setExplain] = useState("");
  const [error, setError] = useState("");
  const [loading, setLoading] = useState("");

  const handleCallOpenAIAPI = async () => {
    console.log(props.prompt + value);
    //console.log(process.env.REACT_APP_API_KEY);
    setLoading(true);
    fetch("https://api.openai.com/v1/completions", {
      method: "POST",
      headers: {
        "Content-Type": "application/json",
        Authorization: `Bearer ${process.env.REACT_APP_API_KEY}`,
      },
      body: JSON.stringify({
        model: "text-davinci-003",
        prompt: <props className="prompt"></props> + value,
        temperature: 0,
        max_tokens: 150,
        top_p: 1.0,
        frequency_penalty: 0.0,
        presence_penalty: 0.0,
        stop: ['"""'],
      }),
    })
      .then((response) => {
        if (!response.ok) {
          throw new Error("Error fetching");
        }
        return response.json();
      })
      .then((data) => {
        console.log(data.choices[0].text);
        setExplain(data.choices[0].text);
      })
      .catch((error) => setError(error.message))
      .finally(() => setLoading(false));
  };

  const handleOnChange = (event) => {
    setValue(event.target.value);
  };

  const disabledButton = isDisabled || !value.length;

  return (
    <div className="container">
      <h1>{props.title}</h1>
      <textarea
        placeholder={props.areaText}
        cols={50}
        rows={20}
        onChange={handleOnChange}
      />
      {/* <Input onChange={handleOnChange} value={value}></Input> */}
      <Button isDisabled={disabledButton} onClick={handleCallOpenAIAPI}>
        {props.buttonText}
      </Button>
      {loading ? <p>Loading...</p> : null}
      {error ? <p>error</p> : null}
      {explain !== "" ? <p>{explain}</p> : null}
    </div>
  );
};
